// Time-stamp: <2002-07-09 13:30:03 zaykin> [written by Dmitri Zaykin]
//
// prints a list of columns from a file
//
// Compilation: g++ pcols.cpp -o pcols.x std/std.a -O3 -Wall

#include "std/stl_hdrs.h"
#include <string>
#include <iostream>
#include <stdio.h>
#include "std/mystrings.h"
#include "std/mtypes.h"

typedef size_t st;

bool Is_An_Integer(const char *s)
{
    while (*s && isspace(*s)) ++s;
    while (*s) {
        if(!isdigit(*s)) return false;
        ++s;
    }
    return true;
}

int main(int ac, char **av)
{    
    ios::sync_with_stdio();
    Vi ix;
    for(int i=1; i<ac; i++) {
        assert(Is_An_Integer(av[i]));
        ix.push_back(atoi(av[i])-1);
    }
    while(cin) {
        string s;
        Vs vs;
        getline(cin, s);
        if(s.length() == 0) break;
        split_string(s, " \t\r", vs);
        for(st i=0; i<ix.size(); i++) {
            if((st)ix[i] < vs.size()) cout << vs[ix[i]] << " ";
        }
        cout << "\n";
    }
}
