#!/bin/sh
#
# Time-stamp: <2002-07-09 13:11:02 zaykin> (Dmitri Zaykin)
#
# Compile all *.cpp files in the current directory; 
# then build the library

CPP=g++
#CPP_FLAGS="-Wall -O3"
#CPP_FLAGS="-Wall -O3 -ffast-math"
CPP_FLAGS="-Wall -O3 -fforce-mem -fforce-addr -fomit-frame-pointer -fexpensive-optimizations"
LIB_NAME=std.a
ECHO=/bin/echo

for EACHFILE in *.cpp *.c
  do
    $ECHO -n "        "
    $ECHO compiling $EACHFILE with $CPP $CPP_FLAGS ...
    $CPP -c $EACHFILE $CPP_FLAGS
done

$ECHO -n "        "; $ECHO building the library $LIB_NAME
ar -rv $LIB_NAME *.o

# $ECHO -n "        "; $ECHO Deleting *.o files...
# /bin/rm *.o

$ECHO ""
$ECHO -n "        "; $ECHO Running ranlib on $LIB_NAME.
$ECHO -n "        "; $ECHO Do not be alarmed if the following ranlib command
$ECHO -n "        "; $ECHO fails due to the absence of a ranlib program on your system.

ranlib $LIB_NAME
$ECHO Done

