// Time-stamp: <2001-03-01 17:26:39 dvz90620> (Dmitri Zaykin)
//

#ifndef _ATTIC_H
#define _ATTIC_H

#include "mymem.h"
#include "marsa.h"
#include <iostream>

double Gengam(double a, double r, Rndm&);

enum { FACTABLESIZE = 500 };
enum { LOGTABLESIZE = 500 };

double IntLog(int n);
void asinCI95(double &p, double &le, double &ri, long n);
void SpitMatrix (int **dat, int rlen, int clen, ostream &CoStr);
void SpitMatrix (int **dat, int *r, int *c, int rlen, int clen, ostream &);
int calc_margins(int **dat, int *r, int *c, int rlen, int clen);
int expected(int *r, int *c, int rlen, int clen, int SampleSize, double **e);
double chi(int **dat, double **e, int PutZeros, int rlen, int clen, int SampleSize);
double GamLn(double xx);
double logfc(int n);
void Spit(int **x, int rlen, int clen);
int** ReadTable(char *InputFile, int &r, int &c);
int** ReadTable(istream& InputFile, int &r, int &c);
double bincoe(int n, int k);
bool Is_A_Number(const char *s);
bool Is_An_Integer_Gt_0(const char *s);
bool Is_An_Integer(const char *s);

struct Timer {
    time_t start, finish;
    void re_start () { start = time (0); }
    time_t operator ()() { return (finish = time(0)) - start; }
};

class RunIndicator
{
    long j, wrap, freq_out, wrap_freq;
    ostream *os;
 public:
    RunIndicator() : j(0), wrap(0), freq_out(100), wrap_freq(25) {
        os = &cerr;
    }
    RunIndicator(long freq_out_, ostream& ost = cerr) : j(0), wrap(0),
        freq_out(freq_out_ ? freq_out_ : 1), wrap_freq(25)
        {
            os = &ost;
        }
    void flush() { *os << endl; }
    void out(const char* s) { *os << s; }
    void go() {
        if(j && !(j % freq_out)) {
            *os << ".";
            if(!(++wrap % wrap_freq)) *os << " " << j << " done\n";
        }
        ++j;
    }
};

#endif
