// Time-stamp: <1998-05-25 12:32:25 dvz90620> (Dmitri Zaykin)
//

#if defined (_Windows)
  #define _WinDog
#endif

#include "mymem.h"

#if defined (_WinDog)
  #include <io.h>
#else
  #include <unistd.h>
#endif

#include <stdio.h>

int IsEmpty(char *word)
{
    while(word && *word) if(!isspace(*word++)) return 0;
    return 1;
}

int GetNumWords(char *ww, const char *set /* = " \t" */ )
{
    char *w = StrDup (ww);
    char *nxt = strtok(w, set);
    int ee=0;
    while(nxt != 0) {
        ++ee;
        nxt = strtok(0, set);
    }
    delete [] w;
    return ee;
}

// search for a match in the vector of cumulative frequencies
double CumulSearch(double *dvect, double what, int len, int *position)
{
 int l=0, r=len;
 while(r >= l)
 {
    int x=(l+r)/2;
    if( x > 0 && dvect[x-1] <= what && dvect[x] >= what ) {
        return dvect[*position=x];
    }
    else if(!x) { return dvect[*position=0]; }
    if( what < dvect[x] ) r=x;
    else l=x+1;
 }
 return -1;
}

float CumulSearch(float *dvect, float what, int len, int *position)
{
 int l=0, r=len;
 while(r >= l)
 {
    int x=(l+r)/2;
    if( x > 0 && dvect[x-1] <= what && dvect[x] >= what ) {
        return dvect[*position=x];
    }
    else if(!x) { return dvect[*position=0]; }
    if( what < dvect[x] ) r=x;
    else l=x+1;
 }
 return -1;
}

int* IntDup (const int *w, int * id_len /* = 0 */ )
{
    int len = IntLen(w);
    int *r = new int [len+1];
    for(int i=0; i<len; i++) { r[i] = w[i]; }
    r[len] = EOLINT;
    if(id_len != 0) *id_len = len;
    return r;
}
 
int IntLen (const int* x)
{
    int i=0;
    while(x[i] != EOLINT) ++i;
    return i;
}

int IntCmp (const int* a, const int* b)
{
    for(int i=0; a[i] != EOLINT && b[i] != EOLINT; i++)  {
        if(a[i] < b[i])  return -1;
        else if(a[i] > b[i])  return 1;
    }
    return 0;
}

int IsValidStr (const char *w, const char *set)
{
    while (*w) if (!strchr (set, *w++)) return 0;
    return 1;
}
 
int CountChars(const char *w, char ch)
{
    int n = 0;
    while (w && *w) if(*w++ == ch) ++n;
    return n;
}

char *unique(const char *name)
{
  unsigned int t = strlen(name);
  int i=0;
  char  digits[] = { 0,0,0,0,0,0,0,0,0,0,0,0 }; // outa be enough!
  char *dname = StrDup (name);
  if(access (name,0)) return dname;
  while(!access(dname,0)) {
      sprintf (digits, "%d", i);
      strncpy(&dname[ t-strlen(digits) ], digits, strlen(digits));
      ++i;
  }
  return dname;
}
